<?php defined('SYSPATH') or die('No direct script access.');
/**
 * class Controller_admin_member
 *
 * Odpowiada za edycje użytkowników
 */
class Controller_admin_member extends Controller_admin
{	

	/**
	 * Konstruktor...
	 * 
	 */
	public function __construct()
	{
		parent::__construct('acp_members');
	}
	

	/**
	 * Wyświetla formularz do edycji użytkownika...
	 *
	 */
	public function action_edit_box()
	{
		$member = Member::load(Core::request()->post('id'));
		
		Core::view()->assign('member',  $member);
		Core::ajax()->assign('title',   $member['id'] ? 'Użytkownik: ' . Member::getDisplayName($member['id']) : 'Błąd');
		Core::ajax()->assign('message', Core::view()->execute('admin/member/edit', TRUE));
		
		Core::ajax()->send(TRUE);
	}
	
	/**
	 * Edytuje użytkownika
	 *
	 */
	public function action_edit()
	{
		$post_data = Core::request()->post();
		$id = $post_data['id'];
		
		if($id == Member::logged() && Member::get('group_id') != $post_data['group_id'])
		{
			Core::ajax()->assign('result',  'error');
			Core::ajax()->assign('message', 'Nie możesz sobie odebrać uprawnień administratora, ktoś musi tutaj panować!');
			Core::ajax()->send();	
		}
		
		$result = true;
		
		$result = $result && Member::update((int)$id, 'login',  $post_data['login']); 
		$result = $result && Member::update((int)$id, 'email',  $post_data['email']); 
		$result = $result && Member::update((int)$id, 'gg',     $post_data['gg']); 
		$result = $result && Member::update((int)$id, 'wallet', $post_data['wallet']); 
		$result = $result && Member::update((int)$id, 'group_id', (int)$post_data['group_id']); 
		
		if ($result)
		{
			$name = Member::getDisplayName($id);
			Logs::add("Edytował użytkownika {$name}", Member::logged(), 'member');
		}
		
		Core::ajax()->assign('result',  $result ? 'success' : 'error');
		Core::ajax()->assign('message', $result ? 'Edycja przebiegła pomyślnie' : 'Coś poszło nie tak');
		Core::ajax()->send();
	}
	
	/**
	 * Usuwa użytkownika
	 *
	 */
	public function action_delete()
	{
		$member_id   = Core::request()->post('id');
		$member_name = Member::getDisplayName($member_id);
		
		$result = Member::delete($member_id);
		
		Core::ajax()->assign('result',  $result[0] ? 'success' : 'error');
		Core::ajax()->assign('message', $result[1]);
		
		if($result[0])
		{
			Logs::add("Usunął użytkownika {$member_name}", Member::logged(), 'member');
		}
		
		Core::ajax()->send();
	}
	
	/**
	 * Blokuje użytkownika...
	 *
	 */
	public function action_block()
	{
		$member_id   = Core::request()->post('id');
		$member_name = Member::getDisplayName($member_id);
		
		$status = Member::block($member_id);
		
		Core::ajax()->assign('result',  $status[0] ? 'success' : 'error');
		Core::ajax()->assign('message', $status[1]);
		
		if(isset($status[2]))
		{
			$member = Member::getDisplayName($member_id);
			
			Logs::add(($status[2] ? "Zablokował użytkownika " : "Odblokował użytkownika ") . $member_name, Member::logged(), 'member');
			
			Core::ajax()->assign('status', $status[2]);
		}
		
		Core::ajax()->send(TRUE);
	}
}