<?php defined('SYSPATH') or die('No direct script access.');
/**
 * class Controller_admin_setting
 *
 * Odpowiada za edycje ustawień...
 */
class Controller_admin_setting extends Controller_admin
{	

	/**
	 * Konstruktor...
	 * 
	 */
	public function __construct()
	{
		parent::__construct('acp_setting');
	}

	/**
	 * Updatuje ustawienia
	 *
	 * @access public
	 */
	public function action_update()
	{
		$result = 0;
		
		$post = Core::request()->post();
		
		// Usługi jakie mają nie zostać pokazane...
		if(!isset($post['service_no_show']))
		{
			$post['service_no_show'] = '';
		}
		else
		{
			$service_no_show = $post['service_no_show'];
			
			$post['service_no_show'] = array();
			foreach($service_no_show as $sid)
			{
				$post['service_no_show'][$sid] = $sid;
			}
			
			$post['service_no_show'] = implode(',', $post['service_no_show']);
		}
		
		// Update...
		foreach($post as $name=>$value)
		{
			$result += Core::setting()->update($name, $value);
		}
		
		if($result > 0)
		{
			Logs::add("Zmodyfikował {$result} ustawień", Member::logged(), 'setting');
		}
		
		Core::ajax()->assign('result',  $result ? 'success' : 'warning');
		Core::ajax()->assign('message', $result ? ('Zmodyfikowana ilość ustawień: ' . $result) : 'Nie zmodyfikowano żadnych ustawień');
		Core::ajax()->send();
	}
}