<?php defined('SYSPATH') or die('No direct script access.');
/**
 * class Controller_member_profile
 *
 * Aktualnie odpowiada za przekazywanie środków i zmiane hasła.
 */
class Controller_member_profile extends Controller_member
{	

	/**
	 * Konstruktor
	 *
	 * @access public
	 */
	public function __construct()
	{
		parent::__construct( TRUE );
	}
	
	/**
	 * ZMiena hasła
	 *
	 * @access public
	 */
	public function action_set_password()
	{
		$data = Core::request()->post();
		
		$result = 0;
		
		if(!Core::setting()->get('member_set_password', 1))
		{
			$message = 'Ta opcja została wyłączona';
		}
		elseif(empty($data['current_password']) or empty($data['new_password']) or empty($data['new_password_confirm']))
		{
			$message = 'Musisz podać wszystkie pola';
		}
		else
		{
			$c  = Member::hash($data['current_password']);
			$n  = Member::hash($data['new_password']);
			$nc = Member::hash($data['new_password_confirm']);
 		
			if($c != Member::get('password'))
			{
				$message = 'Aktaulne hasło nie jest poprawne';
			}
			elseif($n != $nc)
			{
				$message = 'Podane nowe hasła muszą być identyczne';
			}
			elseif($n == $c)
			{
				$message = 'Nowe hasło jest takie same jak aktualne';
			}
			else
			{
				// aktualizacja
				Member::update(Member::logged(), 'password', $n);
				Member::update(Member::logged(), 'password_set', time());
				
				// Dodatkowo informacja w przypadku innego adresu IP
				$ip_adress = Core::request()->getAddr();
				$mb_adress = Member::get('ip_addr');
				
				$_log = "";
				if($ip_adress != $mb_adress)
				{
					$_log = "(jest to adres inny niż ten na którym zostało utworzone konto)";
				}
				
				// wysyłanie logów
				MLogs::add("Hasło zostało zmienone z adresu IP: {$ip_adress}" , 'password', Member::logged());
				Logs::add("Zmienił hasło do konta {$_log}", Member::logged(), 'member');
				
				// wiadomość
				$message  = 'Hasło zostało zmienione';
				$result   = 1;
			}
		}
		
		Core::ajax()->assign('message', $message);
		Core::ajax()->assign('result',  $result);
		Core::ajax()->send();
	}
	
	/**
	 * Przekazywanie środków
	 *
	 * @access public
	 */
	public function action_give()
	{
		$username = Core::request()->post('username', '');
		$amount   = (float)Core::request()->post('amount', 0);
		
		$notif_admin  = Core::request()->post('notif_admin', FALSE);
		$notif_member = Core::request()->post('notif_member', FALSE);
		
		$limit = Core::setting()->get('member_give_money_limit', 0);
		
		if(!Core::setting()->get('member_give_money', 1))
		{
			$message = 'Ta opcja została wyłączona';
		}
		elseif(empty($username) or !$amount)
		{
			$message = 'Nie podałeś nazwy użytkownika / kwoty jaką chcesz przekazać';
		}
		elseif($amount > Member::get('wallet') or ($limit && $amount > $limit))
		{
			$message = 'Nie posiadasz takiej kwoty';
			if($limit && $amount > $limit)
			{
				$message = 'Przekroczyłeś limit dozwolonej kwoty do przekazania';
			}
		}
		elseif(!$member_data = Member::load($username, 'login'))
		{
			$message = 'Taki użytkownik nie istnieje';
		}
		elseif($member_data['id'] == Member::logged())
		{
			$message = 'Nie możesz przekazać tej kwoty na konto z którego aktualnie korzystasz';
		}
		else
		{
			$amount = round($amount, 2);
			
			Member::update($member_data['id'], 'wallet', $member_data['wallet'] + $amount);
			Member::update(Member::logged(),   'wallet', Member::get('wallet')  - $amount);
			
			$display_name_to    = Member::getDisplayName($member_data['id']);
			$display_name_from  = Member::getDisplayName(Member::logged());
			
			$message = "Kwota {$amount} PLN została przekazana użytkownikowi {$display_name_to}";
			
			
			MLogs::add("Użytkownik {$display_name_from} przekazał ci {$amount} PLN", 'wallet', $member_data['id']);
			
			if($notif_member)
			{
				MLogs::add("Przekazano {$amount} PLN użytkownikowi {$display_name_to}", 'wallet', Member::logged());
			}
			
			if($notif_admin)
			{
				Logs::add("Przekazał {$amount} PLN użytkownikowi {$display_name_to}", Member::logged(), 'wallet');
			}
		}
		
		Core::ajax()->assign('message', $message);
		Core::ajax()->send();
	}
}