<?php defined('SYSPATH') or die('No direct script access.');
class AmxBans
{
	/**
	 * Połączone amxbansy...
	 * @private array
	 */
	private $connected = array();

	/**
	 * Zwraca liste amxbansów jakie zostały dodane...
	 *
	 * @return array
	 */
	public function getAmxBansList()
	{
		$query = Core::db()->query('SELECT * FROM `amxbans_sql_info`');
		return $query->fetchAll();
	}
	
	/**
	 * Wybiera z bazy tylko jeden wybrany amxbans
	 *
	 * @param integer
	 * @param string
	 * @return array
	 */
	public function getAmxBans($aid, $type = 'id')
	{
		$query = Core::db()->prepare('SELECT * FROM `amxbans_sql_info` where `'.$type.'` = ?');
		$query->execute(array($aid));
		
		return $query->rowCount() ? $query->fetch() : false;
	}
	
	/**
	 * Edytuje amxbansa...
	 *
	 *
	 * @param array
	 * @return integer
	 */
	public function edit($aid, $data)
	{
		if($data['name'] == '' or $data['host'] == '' or $data['user'] == '' or $data['base'] == '')
		{
			return array(0, 'Któreś z wymaganych pól nie zostało podane');
		}
		
		$stmt = Core::db()->prepare('UPDATE `amxbans_sql_info` set `name`=?, `host`=?, `base`=?, `user`=?, `pass`=?, `prefix`=? where `id`=?');
		$stmt->execute(array($data['name'], $data['host'], $data['base'], $data['user'], $data['pass'], $data['prefix'], $aid));
		$count = $stmt->rowCount();
		
		return array($count, $count ? 'AmxBans został pomyślnie zmodyfikowany' : 'Żadne pola nie zostały zmienione');
	}
	
	/**
	 * Dodaje nowego amxbansa do bazy danych...
	 *
	 * @param array
	 * @return bool
	 */
	public function add($data)
	{
		if($data['name'] == '' or $data['host'] == '' or $data['user'] == '' or $data['base'] == '')
		{
			return array(0, 'Któreś z wymaganych pól jest puste');
		}
		
		if($this->getAmxBans($data['name'], 'name'))
		{
			return array(0, 'AmxBans o takiej nazwie już istnieje w bazie danych');
		}
		
		$exec = Core::db()->prepare('INSERT INTO `amxbans_sql_info` VALUES(NULL, ?, ?, ?, ?, ?, ?)')
					->execute(array($data['name'], $data['host'], $data['base'], $data['user'], $data['pass'], $data['prefix']));
		
		return array($exec, $exec ? 'AmxBans został dodany' : 'Błąd podczas dodawania amxbansa');
	}
	
	/**
	 * Usuwa amxbans'a
	 *
	 * @param integer
	 * @return intger
	 */
	public function deleteAmxBans($aid)
	{
		$result = Core::db()->exec('DELETE FROM `amxbans_sql_info` where `id`='.(int)$aid);
		
		return array($result, $result ? 'AmxBans został usunięty' : 'AmxBans już nie istnieje');
	}
	
	/**
	 * Łączy z odopowniedną klasą obsługującą odpowiedniego amxbansa...
	 *
	 * @param  array
	 * @param  string
	 * @return object
	 */
	public function connect($data, $type = 'GM')
	{
		// Wygenerujmy unikalny klucz dla tego amxbansa
		$key = 'amxbans_id_' . $data['id'];
		
		// Jeśli taki połączenie zostało już nawiązane
		if(isset($this->connected[$key]))
		{
			return $this->connected[$key];
		}
	
		// Utwórzmy nazwę amxbansa
		$amxbans = 'AmxBans_' . $type;
		
		// Utwórzmy objekt klasy amxbansa
		$amxbans = new $amxbans($data);
		
		// Zapiszmy do cache...
		return $this->connected[$key] = $amxbans->connect() ? $amxbans : false;
	}
}
?>
