<?php defined('SYSPATH') or die('No direct script access.');

/**
 * Logi użytkowników
 *
 */
abstract class MLogs
{	
	/**
	 * Zwraca logi użytkownika
	 *
	 * @param integer
	 * @param string
	 *
	 * @access static
	 * @return array
	 */
	static public function get($member_id, $section)
	{
		$stmt = Core::db()->prepare('SELECT * FROM `member_logs_` WHERE `section` = ? and `member_id` = ? order by `id` DESC');
		$stmt -> execute(array($section, $member_id));
		return $stmt->fetchAll();
	}
	
	/**
	 * Dodaje log 
	 *
	 * @param string
	 * @param string
	 * @param integer
	 * 
	 * @access static
	 * @return bool
	 */
	static public function add($message, $section, $member_id = 0)
	{
		$member_id = $member_id ? $member_id : Member::logged();
		
		return Core::db()->prepare('INSERT INTO `member_logs_` VALUES(NULL, ?, ?, ?, UNIX_TIMESTAMP(), 0)')
					->execute(array($member_id, $message, $section));
	}
	
	/**
	 * Usuwa log
	 *
	 * @param integer
	 *
	 * @access static
	 * @return array
	 */
	static public function delete($id)
	{
		$stmt = Core::db()->prepare('DELETE FROM `member_logs_` where `id` = ? LIMIT 1');
		$stmt->execute(array($id));
		
		$c = $stmt->rowCount();
		return array($c, $c ? 'Powiadomienie zostało usunięte' : 'Takie powiadomienie nie istnieje');
	}
	
	/**
	 * Zmienia status na przeczytany
	 *
	 * @access static
	 * @return integer
	 */
	static public function setStatusToActive($member_id, $section)
	{
		$stmt = Core::db()->prepare('UPDATE `member_logs_` SET `status` = 1 WHERE `section` = ? AND `member_id` = ?');
		$stmt->execute(array($section, $member_id));
		
		return $stmt->rowCount();
	}
}