<?php defined('SYSPATH') or die('No direct script access.');

class Payments_Homepay
{
	protected $rates  = array( 
		7055 => array( 0.61,  0.25, 13533 ),
		7155 => array( 1.23,  0.50, 13534 ),
		7255 => array( 2.46,  1.00, 13535 ),
		7455 => array( 4.92,  2.00, 13536 ),
		7655 => array( 7.38,  3.00, 13427 ),
		7955 => array( 11.07,  4.50, 13428 ) 
	);
	
	/**
	 * Sprawdza poprawność kodu sms...
	 *
	 * @param  $sms    string kod sms
	 * @param  $numer  string opcjonalnie, numer na który został wysłany sms
	 * @param  $code   string opcjonalnie, treść smsa jaką wysłał użytkownik
	 *
	 * @access public
	 * @return float Kwota jaką ma zostać zasilony portfel
	 */
	public function check( $sms, $numer = NULL, $code = NULL ) {
		$user	= Core::setting( ) -> get( 'homepay_key_api' );
		$fp 	= fopen( "http://homepay.pl/API/check_code.php?usr_id=$user&acc_id=".$this -> getType( $numer )."&code=$sms", 'r' );
		$get 	= fgets( $fp, 8 );
		
		fclose( $fp );
		
		if( $get == '1' )
			return array( $this -> rates[ $numer ][ 1 ], 'Konto zostało pomyślnie doładowane' );
			
		return array( 0.0, 'Wystąpił błąd...' );
	}
	
	/**
	 * Zwraca identyfikator dla danego numeru...
	 *
	 * @param integer
	 * @return integer
	 */
	private function getType( $numer ) {
		return $this -> rates[ $numer ][ 2 ];
	}
	
	/**
	 * Stawki sms
	 *
	 *
	 * @access public
	 * @return array zwraca tablice ze stawkami sms(numer, koszt, tresc)
	 */
	public function rates( ) {
		foreach( $this -> rates as $key => $rate ) {
			$_return[ ] = array(
				'numer'    => $key,
				'text_sms' => Core::setting( ) -> get( 'homepay_text_sms' ),
				'cost'	   => $rate[0],
				'amount'   => $rate[1] 
			);
		}
		
		return $_return;
	}
}

?>