<?php defined('SYSPATH') or die('No direct script access.');

abstract class Rcon {
		static protected $cnr = 0;

		static public function sendCommand( $address, $rcon = "", $command = "", $pagenumber = 0, $single = true ) {
			if( empty( $address ) || empty( $rcon ) || empty( $command ) )
				return;
		
			$address 		= @explode( ":", $address );
			$address[ 0 ] 	= getHostByName( $address[ 0 ] );
			
			$fp = fsockopen( 'udp://'.$address[ 0 ], $address[ 1 ], $errno, $errstr, 2 );
			
			stream_set_timeout( $fp, 2 );
			
			if( !$fp ) 
				return;
			
			self::getChallenge( $fp );
			
			$command = "\xff\xff\xff\xffrcon ".self::$cnr." \"$rcon\" $command\n";
			
			$result = "";
			$buffer = "";
			while( $pagenumber >= 0 ) {
				 $buffer .= substr( self::Communicate( $fp, $command ), 1 );
				 
				 if( $single )
					$result = $buffer;
				else
					$result .= $buffer;

				$command = "";

				$pagenumber--;
			}
			return trim( $result );
		}
		
		static private function getChallenge( $fp ) {
			if( !empty( self::$cnr ) ) 
				return;
			
			$challenge 	= "\xff\xff\xff\xffchallenge rcon\n";
			$buffer 	= self::Communicate( $fp, $challenge );
			
			if( trim( $buffer ) == "" )
				return;
				
			self::$cnr = trim( substr( $buffer, 15 ) );	
		}
		
		static private function Communicate( $fp, $command ) {
			if( !empty( $command ) )
				fputs( $fp, $command, strlen( $command ) );
				
			$buffer = fread( $fp, 1 );
			$status = socket_get_status( $fp );
			
			if( $status[ 'unread_bytes' ] > 0 ) 
				$buffer .= fread( $fp,  $status[ 'unread_bytes' ] );
			
			if( substr( $buffer, 0, 4 ) == "\xfe\xff\xff\xff" ) {
				$requestid = substr( $buffer, 4, 4 );
				
				$po 	= ord( substr( $buffer, 8, 1 ) );
				$panum 	= ( $po & 1 ) + ( $po & 2 ) + ( $po & 4 ) + ( $po & 8 );
				$po 	= $po >> 4;
				$pacur 	= ( $po & 1 ) + ( $po & 2 ) + ( $po & 4 ) + ( $po & 8 );
				
				if( $pacur == ( $panum - 1 ) ) 
					$splitbuffer[ $pacur ] = substr( $buffer, 9 );
				else 
					$splitbuffer[ $pacur ] = substr( $buffer, 14 );
					
				for( $i = 1; $i < $panum; $i++ ) {
					$buffer2 	= fread( $fp, 1 );
					$status 	= socket_get_status( $fp );
					$buffer2 	.= fread( $fp, $status[ 'unread_bytes' ] );
					
					$requestid2 = substr( $buffer, 4, 4 );
					$po 		= ord( substr( $buffer2, 8, 1 ) );
					$po 		= $po >> 4;
					$pacur 		= ( $po & 1 ) + ( $po & 2 ) + ( $po & 4 ) + ( $po & 8 );
			
					if( $requestid == $requestid2 ) {
						if( $pacur == ( $panum - 1 ) )
							$splitbuffer[ $pacur ] = substr( $buffer2, 9 );
						else
							$splitbuffer[ $pacur ] = substr( $buffer2, 14);
						
					}
				}
				
				for( $i = 0; $i < $panum; $i++ ) 
					$bufferret .= $splitbuffer[ $i ];
			}  else
				$bufferret = substr( $buffer, 4 );
				
			return $bufferret;
		}
	}
?>