<?php defined('SYSPATH') or die('No direct script access.');

abstract class Date
{

	const MINUTE = 60;
	const HOUR   = 3600;
	const DAY    = 86400;
	const WEEK   = 604800;
	const MONTH  = 2629744;
	const YEAR   = 31556926;
	

	/**
	 * Formatuje czas
	 *
	 * @param integer
	 *
	 * @access static
	 * @return string
	 */
	static public function format($time)
	{
		$periods = array('sekund', 'minut', 'godzin', 'dni', 'tygodni', 'miesięcy', 'lat', 'dekad');
		$lengths = array(60, 60, 24, 7, 4.35, 12, 10);

		$now = time();
		
		$difference = $now - $time;
		$c          = count($lengths)-1;
		
		for($j = 0; $difference >= $lengths[$j] && $j < $c; $j++)
		{
			$difference /= $lengths[$j];
		}

		$difference = round($difference);
	
	   return $difference . ' ' . $periods[$j] . ' temu';
	}
	
	/**
	 * Zwraca czas generowania strony
	 *
	 * @return string
	 */
	static public function generate_time()
	{
		$gen_time = microtime(TRUE)-START_TIME;
		$gen_time = round($gen_time, 4);
		
		return round(microtime(TRUE)-START_TIME, 5);
	}
	
	/**
	 * Zwraca aktualny czas jako string (Niedziela 29 wrzesień 2013 00:28:28)
	 *
	 * @return string
	 */
	static public function strtime($time = 0, $encode_one = 'ISO-8859-2', $encode_two = 'UTF-8', $format = '%A %d %B %Y')
	{
		$time = !$time ? time() : $time;
		
		return iconv($encode_one, $encode_two, ucfirst(strftime($format, $time))) . ' ' . date('H:i:s', $time);
	}
}