<?php defined('SYSPATH') or die('No direct script access.');
abstract class Session
{
	/**
	 * Przechowuje obiekt klasy
	 * @static object
	 */
	static $class = null;

	/**
	 * Inicjuje klase
	 */
	public static function initialize($type, $arg = array())
	{
		// Wygenerujmy nazwe klasy...
		$session_class_name = 'Session_' . $type;
		
		// Utwórzmy i zapiszmy obiekt klasy do obsługi sesji
		Session::$class = new $session_class_name($arg);
	}
	
	/**
	 * To samo co wyżej tylko bez referencji
	 *
	 * @param string
	 * @param string
	 */
	public static function get($key, $default=NULL)
	{
		return Session::$class->get($key, $default);
	}
	
	/**
	 * Zmienia wartość sesji
	 * @param string
	 * @param string
	 */
	public static function set($key, $value)
	{
		Session::$class->set($key, $value);
	}
	
	/**
	 * Usuwa segment z sesji
	 *
	 * @param $key string
	 */
	public static function delete($key)
	{
		Session::$class->delete($key);
	}
}